"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.State = void 0;

var _classPrivateFieldLooseBase2 = _interopRequireDefault(require("@babel/runtime/helpers/classPrivateFieldLooseBase"));

var _classPrivateFieldLooseKey2 = _interopRequireDefault(require("@babel/runtime/helpers/classPrivateFieldLooseKey"));

var _file2 = require("@skyekiwi/file");

var _util = require("@skyekiwi/util");

// Copyright 2021 @skyekiwi/s-contract authors & contributors
// SPDX-License-Identifier: Apache-2.0
var _key = /*#__PURE__*/(0, _classPrivateFieldLooseKey2.default)("key");

var _file = /*#__PURE__*/(0, _classPrivateFieldLooseKey2.default)("file");

var _state = /*#__PURE__*/(0, _classPrivateFieldLooseKey2.default)("state");

class State {
  constructor(state) {
    Object.defineProperty(this, _key, {
      writable: true,
      value: void 0
    });
    Object.defineProperty(this, _file, {
      writable: true,
      value: void 0
    });
    Object.defineProperty(this, _state, {
      writable: true,
      value: void 0
    });
    (0, _classPrivateFieldLooseBase2.default)(this, _file)[_file] = state;
  }

  async init() {
    try {
      const logsRaw = await (0, _classPrivateFieldLooseBase2.default)(this, _file)[_file].readAll();
      const logs = logsRaw.split('|');
      (0, _classPrivateFieldLooseBase2.default)(this, _key)[_key] = (0, _util.hexToU8a)((0, _util.fromBase64)(logs[0]));
      (0, _classPrivateFieldLooseBase2.default)(this, _state)[_state] = (0, _util.fromBase64)(logs[1]);
    } catch (err) {
      throw new Error('state file initialization error - s-contract/state/init'); // pass
      // the state file is empty
    }
  }

  injectSealer(queue) {
    queue.unlockSealer((0, _classPrivateFieldLooseBase2.default)(this, _key)[_key]);
  }

  getState() {
    return (0, _classPrivateFieldLooseBase2.default)(this, _state)[_state];
  }

  updateState(state) {
    (0, _classPrivateFieldLooseBase2.default)(this, _state)[_state] = state;
  }

  async writeState(path) {
    const content = (0, _util.toBase64)((0, _util.u8aToHex)((0, _classPrivateFieldLooseBase2.default)(this, _key)[_key])) + '|' + (0, _util.toBase64)((0, _classPrivateFieldLooseBase2.default)(this, _state)[_state]);
    await _file2.File.writeFile((0, _util.stringToU8a)(content), path, 'w');
  } // not used for production


  forceUpdate(key, state) {
    (0, _classPrivateFieldLooseBase2.default)(this, _key)[_key] = key;
    (0, _classPrivateFieldLooseBase2.default)(this, _state)[_state] = state;
  }

}

exports.State = State;