import _classPrivateFieldLooseBase from "@babel/runtime/helpers/esm/classPrivateFieldLooseBase";
import _classPrivateFieldLooseKey from "@babel/runtime/helpers/esm/classPrivateFieldLooseKey";
// Copyright 2021 @skyekiwi/s-contract authors & contributors
// SPDX-License-Identifier: Apache-2.0
import { File } from '@skyekiwi/file';
import { fromBase64, hexToU8a, stringToU8a, toBase64, u8aToHex } from '@skyekiwi/util';

var _key = /*#__PURE__*/_classPrivateFieldLooseKey("key");

var _file = /*#__PURE__*/_classPrivateFieldLooseKey("file");

var _state = /*#__PURE__*/_classPrivateFieldLooseKey("state");

export class State {
  constructor(state) {
    Object.defineProperty(this, _key, {
      writable: true,
      value: void 0
    });
    Object.defineProperty(this, _file, {
      writable: true,
      value: void 0
    });
    Object.defineProperty(this, _state, {
      writable: true,
      value: void 0
    });
    _classPrivateFieldLooseBase(this, _file)[_file] = state;
  }

  async init() {
    try {
      const logsRaw = await _classPrivateFieldLooseBase(this, _file)[_file].readAll();
      const logs = logsRaw.split('|');
      _classPrivateFieldLooseBase(this, _key)[_key] = hexToU8a(fromBase64(logs[0]));
      _classPrivateFieldLooseBase(this, _state)[_state] = fromBase64(logs[1]);
    } catch (err) {
      throw new Error('state file initialization error - s-contract/state/init'); // pass
      // the state file is empty
    }
  }

  injectSealer(queue) {
    queue.unlockSealer(_classPrivateFieldLooseBase(this, _key)[_key]);
  }

  getState() {
    return _classPrivateFieldLooseBase(this, _state)[_state];
  }

  updateState(state) {
    _classPrivateFieldLooseBase(this, _state)[_state] = state;
  }

  async writeState(path) {
    const content = toBase64(u8aToHex(_classPrivateFieldLooseBase(this, _key)[_key])) + '|' + toBase64(_classPrivateFieldLooseBase(this, _state)[_state]);
    await File.writeFile(stringToU8a(content), path, 'w');
  } // not used for production


  forceUpdate(key, state) {
    _classPrivateFieldLooseBase(this, _key)[_key] = key;
    _classPrivateFieldLooseBase(this, _state)[_state] = state;
  }

}